var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useContext, useCallback, useState } from 'react';
import { ApiContext } from '../components/ApiClient';
/**
 * Hook to execute a post request
 * @param path
 * @param config
 */
var usePost = function (path, config) {
    var _a = useState(false), loading = _a[0], setLoading = _a[1];
    var _b = useContext(ApiContext), client = _b.client, strictJSON = _b.strictJSON;
    var sendRequest = useCallback(function (_a) {
        var payload = _a.payload, id = _a.id, configOverride = _a.config;
        return __awaiter(void 0, void 0, void 0, function () {
            var _b, entityType, formData, device, data, bodyFormData_1, method, response, e_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _b = config || {}, entityType = _b.entityType, formData = _b.formData, device = _b.device;
                        data = {};
                        if (formData && payload) {
                            bodyFormData_1 = new FormData();
                            Object.keys(payload).forEach(function (fieldKey) {
                                bodyFormData_1.append(fieldKey, payload[fieldKey]);
                            });
                            bodyFormData_1.append('device_name', device || '');
                            data = bodyFormData_1;
                        }
                        else if (strictJSON) {
                            data = {
                                data: {
                                    type: entityType,
                                    id: id,
                                    attributes: payload
                                }
                            };
                        }
                        else {
                            data = payload;
                        }
                        setLoading(true);
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 10, , 11]);
                        method = (config || {}).method;
                        response = null;
                        if (!(method === 'put')) return [3 /*break*/, 3];
                        return [4 /*yield*/, client.doPut(path, __assign(__assign(__assign({}, config), { data: data }), configOverride))];
                    case 2:
                        response = _c.sent();
                        return [3 /*break*/, 9];
                    case 3:
                        if (!(method === 'patch')) return [3 /*break*/, 5];
                        return [4 /*yield*/, client.doPatch(path, __assign(__assign(__assign({}, config), { data: data }), configOverride))];
                    case 4:
                        response = _c.sent();
                        return [3 /*break*/, 9];
                    case 5:
                        if (!(method === 'delete')) return [3 /*break*/, 7];
                        return [4 /*yield*/, client.doDelete(path, __assign(__assign(__assign({}, config), { data: data }), configOverride))];
                    case 6:
                        response = _c.sent();
                        return [3 /*break*/, 9];
                    case 7: return [4 /*yield*/, client.doPost(path, __assign(__assign(__assign({}, config), { data: data }), configOverride))];
                    case 8:
                        response = _c.sent();
                        _c.label = 9;
                    case 9:
                        setLoading(false);
                        return [2 /*return*/, response];
                    case 10:
                        e_1 = _c.sent();
                        setLoading(false);
                        throw e_1;
                    case 11: return [2 /*return*/];
                }
            });
        });
    }, [setLoading, config, path]);
    return [sendRequest, loading];
};
export default usePost;
//# sourceMappingURL=usePost.js.map